# data manager
from .data_manager import DataManager

# text processor
from .text_processor import TextProcessor
from .text_processors import DefaultTextProcessor

# attacker
from .attacker import Attacker
from . import attackers

# classifier
from .classifier import Classifier

from .classifiers import PytorchClassifier, TensorflowClassifier, HuggingfaceClassifier
from . import classifiers

# attack_eval
from .attack_eval import AttackEval
from .attack_evals import DefaultAttackEval
from . import attack_evals

# exception
from . import exceptions
from .exception import AttackException

# substitute
from .substitute import Substitute
from . import substitutes

# utils
from . import utils

download = DataManager.download
load = DataManager.load
loadDataset = DataManager.loadDataset
loadAttackAssist = DataManager.loadAttackAssist
loadVictim = DataManager.loadVictim
loadTProcess = DataManager.loadTProcess

from .version import VERSION as __version__